import java.util.Iterator;
import java.util.Vector;

public class LinkedStack<E> implements StackInterface<E> {

	private Node<E> top = null;
	private int size = 0;
	
	
	@Override
	public Iterator<E> iterator() {
		Vector<E> vector = new Vector<E>(this.size);
		
		Node<E> currentNode = this.top;
		
		while (currentNode != null) {
			vector.add(currentNode.getData());
			currentNode = currentNode.getPrevious();
		}
		
		ElementIterator<E> iterator = new ElementIterator<E>(vector);
		return iterator;
		
	}

	@Override
	public boolean isEmpty() {
		return (this.size == 0) ? true : false;
	}

	@Override
	public int size() {
		return this.size;
	}

	@Override
	public void push(E e) throws IllegalStateException, NullPointerException {
		if (e == null) {
			throw new NullPointerException("null element cannot be pushed onto the stack");
		}
		
		Node<E> node = new Node(e);
		
		if (this.isEmpty()) {
			this.top = node;
		} else {
			this.top.setNext(node);
			node.setPrevious(this.top);
			this.top = node;
		}
		
		this.size++;
	}

	@Override
	public E peek() {
		if (this.isEmpty()) {
			return null;
		}

		return this.top.getData();
	}

	@Override
	public E pop() {
		if (this.isEmpty()) {
			return null;
		}
		
		E element = this.top.getData();
		
		if (this.size == 1) {
			this.top = null;
		} else {
			Node<E> previousNode = this.top.getPrevious();
			previousNode.setNext(null);
			this.top = previousNode;
		}
		
		this.size--;
		return element;
		
	}

	@Override
	public void clear() {
		this.top = null;
		this.size = 0;
	}

}
